image: node:12

stages:
  - test
  - staging
  - production

variables:
  SERVICE_NAME_STAGING: homebot-staging
  SERVICE_NAME_PRODUCTION: homebot-production

test:
  stage: test
  script:
    - npm install
    - npm run lint
  only:
    - master

deploy_server_staging:
  stage: staging
  environment: staging
  script:
    - echo "deb http://packages.cloud.google.com/apt cloud-sdk-jessie main" | tee /etc/apt/sources.list.d/google-cloud-sdk.list
    - curl https://packages.cloud.google.com/apt/doc/apt-key.gpg | apt-key add -
    - apt-get update
    - apt-get -qq -y install google-cloud-sdk
    - echo $DEPLOY_KEY_FILE_STAGING > /tmp/$CI_PIPELINE_ID.json
    - gcloud auth activate-service-account --key-file /tmp/$CI_PIPELINE_ID.json
    - gcloud config set project $GCLOUD_PROJECT_ID_STAGING
    - gcloud builds submit --tag gcr.io/$GCLOUD_PROJECT_ID_STAGING/$SERVICE_NAME_STAGING
    - gcloud run deploy $SERVICE_NAME_STAGING --region europe-west1 --image gcr.io/$GCLOUD_PROJECT_ID_STAGING/$SERVICE_NAME_STAGING --platform managed
  after_script:
    - rm /tmp/$CI_PIPELINE_ID.json
  only:
    - master

build_server_production:
  stage: production
  environment: production
  script:
    - echo "deb http://packages.cloud.google.com/apt cloud-sdk-jessie main" | tee /etc/apt/sources.list.d/google-cloud-sdk.list
    - curl https://packages.cloud.google.com/apt/doc/apt-key.gpg | apt-key add -
    - apt-get update
    - apt-get -qq -y install google-cloud-sdk
    - echo $DEPLOY_KEY_FILE_PRODUCTION > /tmp/$CI_PIPELINE_ID.json
    - gcloud auth activate-service-account --key-file /tmp/$CI_PIPELINE_ID.json
    - gcloud config set project $GCLOUD_PROJECT_ID_PRODUCTION
    - gcloud builds submit --tag gcr.io/$GCLOUD_PROJECT_ID_PRODUCTION/$SERVICE_NAME_PRODUCTION
  after_script:
    - rm /tmp/$CI_PIPELINE_ID.json
  only:
    - master

deploy_server_production:
  stage: production
  environment: production
  script:
    - echo "deb http://packages.cloud.google.com/apt cloud-sdk-jessie main" | tee /etc/apt/sources.list.d/google-cloud-sdk.list
    - curl https://packages.cloud.google.com/apt/doc/apt-key.gpg | apt-key add -
    - apt-get update
    - apt-get -qq -y install google-cloud-sdk
    - echo $DEPLOY_KEY_FILE_PRODUCTION > /tmp/$CI_PIPELINE_ID.json
    - gcloud auth activate-service-account --key-file /tmp/$CI_PIPELINE_ID.json
    - gcloud config set project $GCLOUD_PROJECT_ID_PRODUCTION
    - gcloud run deploy $SERVICE_NAME_PRODUCTION --region europe-west1 --image gcr.io/$GCLOUD_PROJECT_ID_PRODUCTION/$SERVICE_NAME_PRODUCTION --platform managed
  after_script:
    - rm /tmp/$CI_PIPELINE_ID.json
  only:
    - tags
    - /^production-deploy.*/
